VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmChannelEditor 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Channel Editor"
   ClientHeight    =   3000
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   4545
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3000
   ScaleWidth      =   4545
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox Combo1 
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00000000&
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   2520
      Width           =   2655
   End
   Begin RichTextLib.RichTextBox txt 
      Height          =   2295
      Left            =   135
      TabIndex        =   1
      Top             =   135
      Width           =   4290
      _ExtentX        =   7567
      _ExtentY        =   4048
      _Version        =   393217
      BackColor       =   16777215
      BorderStyle     =   0
      ScrollBars      =   2
      Appearance      =   0
      TextRTF         =   $"frmChannelEditor.frx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Tahoma"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Image cmdSave 
      Height          =   405
      Left            =   3390
      Picture         =   "frmChannelEditor.frx":007B
      Top             =   2520
      Width           =   1050
   End
   Begin VB.Shape Shape1 
      BorderColor     =   &H00FFC0C0&
      Height          =   2340
      Left            =   120
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "frmChannelEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim sChannels() As New Collection
Dim sServers() As String
Dim bChanged As Boolean
Dim iIndex As Integer

Private Sub cmdSave_Click()
    If iIndex > 0 Then
        Dim iDel As Integer
        For iDel = sChannels(iIndex).Count To 1 Step -1
            sChannels(iIndex).Remove iDel
        Next
        
        Dim iAdd As Integer
        Dim sLines() As String
        sLines = Split(txt.Text, vbCrLf)
        For iAdd = 0 To UBound(sLines())
            If (Len(sLines(iAdd)) > 0) Then
                sChannels(iIndex).Add sLines(iAdd)
            End If
        Next
    End If
    
    Open App.Path & "\Channels.db" For Append As #1: Close #1
    Open App.Path & "\Channels.db" For Output As #1
        Dim iLoop As Integer, iLoop2 As Integer
        For iLoop = 0 To UBound(sChannels())
            Debug.Print "sServers:" & iLoop & ":" & sServers(iLoop)
            Debug.Print sChannels(iLoop).Count
            For iLoop2 = 1 To sChannels(iLoop).Count
                If Len(sChannels(iLoop).Item(iLoop2)) > 0 Then
                    Print #1, sChannels(iLoop).Item(iLoop2) & "" & sServers(iLoop)
                End If
            Next iLoop2
        Next iLoop
    Close #1
    DisplayList Channels, Active
End Sub

Private Sub Combo1_Click()
    Dim iMsg As VbMsgBoxResult
    iMsg = vbNo
    If bChanged = True Then iMsg = MsgBox("Save changes?", vbQuestion + vbYesNo, "Channels Changed...")
    
    If iMsg = vbYes Then
        cmdSave_Click
    Else
        Dim iSvr As Integer
        iSvr = ServerIndex
        If iSvr > -1 Then
            txt.Text = vbNullString
            Dim iLoop As Integer
            For iLoop = 1 To sChannels(iSvr).Count
                txt.Text = txt.Text & sChannels(iSvr).Item(iLoop) & vbCrLf
            Next
            bChanged = False
            iIndex = iSvr
        End If
    End If
End Sub

Private Function ServerIndex() As Integer
    ServerIndex = -1
    If Combo1.ListCount > 0 Then
        If Len(Combo1.Text) > 0 Then
            Dim iLoop As Integer
            For iLoop = 0 To UBound(sServers())
                If sServers(iLoop) = Combo1.Text Then
                    ServerIndex = iLoop
                    Exit For
                End If
            Next
        End If
    End If
End Function

Private Sub Form_Load()
    ReDim sChannels(0)
    ReDim sServers(0)
    fLoad
End Sub

Private Sub fLoad()
    Dim sLine As String, sChannel As String, sServer As String
    Open App.Path & "\Channels.db" For Append As #1: Close #1
    Open App.Path & "\Channels.db" For Input As #1
        Do Until EOF(1)
            Line Input #1, sLine
                If InStr(sLine, "") > 0 Then
                    sChannel = Left(sLine, InStrRev(sLine, "") - 1)
                    sServer = Mid(sLine, InStrRev(sLine, "") + 1)
                    Debug.Print sServer
                    Debug.Print sChannel
                    If Len(sServer) > 0 And Len(sChannel) > 0 Then
                        If UBound(sServers()) = 0 Then
                            If Len(sServers(0)) > 0 Then
                                If UCase$(sServer) = UCase$(sServers(0)) Then
                                    sChannels(0).Add sChannel
                                Else
                                    ReDim Preserve sChannels(1)
                                    ReDim Preserve sServers(1)
                                    sServers(1) = sServer
                                    sChannels(1).Add sChannel
                                    Combo1.AddItem sServer
                                End If
                            Else
                                sServers(0) = sServer
                                sChannels(0).Add sChannel
                                Combo1.AddItem sServer
                            End If
                        Else
                            Dim iLoop As Integer, isFound As Boolean
                            For iLoop = 0 To UBound(sServers())
                                If UCase$(sServers(iLoop)) = UCase$(sServer) Then
                                    sChannels(iLoop).Add sChannel
                                    isFound = True
                                    Exit For
                                End If
                            Next
                            
                            If Not isFound Then
                                ReDim Preserve sChannels(UBound(sChannels()) + 1)
                                ReDim Preserve sServers(UBound(sServers()) + 1)
                                sChannels(UBound(sChannels())).Add sChannel
                                sServers(UBound(sServers())) = sServer
                                Combo1.AddItem sServer
                            End If
                        End If
                    End If
                End If
        Loop
    Close #1
    If Combo1.ListCount > -1 Then Combo1.ListIndex = 0
    Combo1_Click
End Sub

Private Sub txt_Change()
    bChanged = True
End Sub

Private Sub txt_KeyPress(KeyAscii As Integer)
    bChanged = True
End Sub
