Attribute VB_Name = "MCES_Documentation"
Public Const IDM_READ& = &H2
Public Const IDM_ADD& = &H1
Public Const IDM_EMPTY& = &H3
Public Const IDM_COUNT& = &H4
Public Const IDU_ADD& = &H0
Public Const IDU_REMOVE& = &H1

Public Const ID_KEEPALIVE& = &H0
'-----------------------------
'ID_KEEPALIVE (0x00) [C=>S]
'-----------------------------
'    C=>S
'     (NULL)
'    Send every 3 minutes
'
Public Const ID_ACCOUNTLOGON& = &H1
'-----------------------------
'ID_ACCOUNTLOGON (0x01) [C=>S=>C]
'-----------------------------
'    C=>S
'     (STRING) Account
'     (STRING) Password
'
'    S=>C
'     (BYTE) Result
'
Public Const ID_ACCOUNTADD& = &H2
'-----------------------------
'ID_ACCOUNTADD (0x02) [S=>C]
'-----------------------------
'    S=>C
'     (STRING) Account
'
Public Const ID_ACCOUNTREM& = &H3
'-----------------------------
'ID_ACCOUNTREM (0x03) [S=>C]
'-----------------------------
'    S=>C
'     (STRING) Account
'
Public Const ID_ACCOUNTUPDATE& = &H4
'-----------------------------
'ID_ACCOUNTUPDATE (0x04) [S=>C]
'-----------------------------
'    S=>C
'     (STRING) Account
'
Public Const ID_ACCOUNTLIST& = &H5
'-----------------------------
'ID_ACCOUNTLIST (0x05) [S=>C]
'-----------------------------
'    S=>C
'     (DWORD) Count
'     For Each:
'      (STRING) Username
'
Public Const ID_ACCOUNTUSERACTION& = &H6
'-----------------------------
'ID_ACCOUNTUSERACTION (0x06) [C=>S]
'-----------------------------
'    C=>S
'     (DWORD) Status
'     (STRING) Username
'
Public Const ID_USERLIST& = &H7
'-----------------------------
'ID_USERLIST (0x07) [S=>C]
'-----------------------------
'    S=>C
'     (DWORD) Count
'     For Each:
'      (STRING) Username
'      (STRING) Client
'      (STRING) Server
'
Public Const ID_USERADD& = &H8
'-----------------------------
'ID_USERADD (0x08) [S=>C]
'-----------------------------
'    S=>C
'     (STRING) Username
'     (STRING) Client
'     (STRING) Server
'
Public Const ID_USERREMOVE& = &H9
'-----------------------------
'ID_USERREMOVE (0x09) [S=>C]
'-----------------------------
'    S=>C
'     (STRING) Username
'
Public Const ID_REQUESTIP& = &HA
'-----------------------------
'ID_REQUESTIP (0x0A) [C=>S=>C]
'-----------------------------
'    C=>S
'     (STRING) Username
'
'    S=>C
'     (BYTE) Result
'     Result = 1 ...
'      (BYTE) IP Part 1
'      (BYTE) IP Part 2
'      (BYTE) IP Part 3
'      (BYTE) IP Part 4
'
Public Const ID_IPQUERY& = &HB
'-----------------------------
'ID_IPQUERY (0x0B)  [S=>C=>S]
'-----------------------------
'    S=>C
'     (STRING) Account
'
'    C=>S
'     (BYTE) Result
'
Public Const ID_MAIL& = &HC
'-----------------------------
'ID_MAIL (0x0C)  [C=>S=>C]
'-----------------------------
'    C=>S
'     (BYTE) Action
'     (VOID) Optional Data

'    S=>C
'     (BYTE) Action
'     (VOID) Optional Data
'
Public Const ID_MAIL_RECEIVED& = &HD
'-----------------------------
'ID_MAIL_RECEIVED (0x0D)  [S=>C]
'-----------------------------
'    C=>S
'     (BYTE) Action
'     (VOID) Optional Data

'    S=>C
'     (BYTE) Action
'     (VOID) Optional Data
'
Public Const ID_MONITORLIST& = &HE
'-----------------------------
'ID_MONITORLIST (0x0E)  [S=>C]
'-----------------------------
'    S=>C
'     (DWORD) Count
'     For Each:
'      (STRING) Username
'      (DWORD) Status
'
Public Const ID_MONITORADD& = &HF
'-----------------------------
'ID_MONITORADD (0x0F)  [C=>S=>C]
'-----------------------------
'    C=>S
'     (STRING) Username
'
'    S=>C
'     (BYTE) Result
'     (STRING) Username
'     (DWORD) Status
'
Public Const ID_MONITORREM& = &H10
'-----------------------------
'ID_MONITORREM (0x10)  [C=>S=>C]
'-----------------------------
'    C=>S
'     (STRING) Username
'
'    S=>C
'     (BYTE) Result
'     (STRING) Username
'
Public Const ID_MONITORUPDATE& = &H11
'-----------------------------
'ID_MONITORUPDATE (0x11)  [S=>C]
'-----------------------------
'    S=>C
'     (STRING) Username
'     (DWORD) Status





