Attribute VB_Name = "RT_Definitions"
'///////////////////////////////////////
' MirageChat v2* Created by DDA-TriCk-E
' Source Release Date: 4th April 2006
'///////////////////////////////////////
'  DLL Imports
'---------------------------
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
    Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
    Public Declare Function GetTickCount Lib "kernel32.dll" () As Long
    Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
    Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
    Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
    Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
    Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
    Public Declare Function GetSystemDefaultLangID Lib "kernel32" () As Long
    Public Declare Function GetSystemDefaultLCID Lib "kernel32" () As Long
    Public Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
    Public Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
    Public Declare Function GetUserDefaultLCID Lib "kernel32" () As Long
    Public Declare Function GetUserDefaultLangID Lib "kernel32" () As Integer
    Public Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long
    Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, _
    ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, _
    ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
    Public Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
    Public Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryA" (ByVal lpPathName As String, lpSecurityAttributes As Long) As Long
    Public Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long
    Public Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
    Public Declare Function MoveFile Lib "kernel32" Alias "MoveFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String) As Long
    Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
    Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
    Public Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long

    Public Type SHFILEOPSTRUCT
        hwnd As Long
        wFunc As Long
        pFrom As String
        pTo As String
        fFlags As Integer
        fAborted As Boolean
        hNameMaps As Long
        sProgress As String
    End Type
    
    Public Const GENERIC_WRITE = &H40000000
    Public Const OPEN_EXISTING = 3
    Public Const FILE_SHARE_READ = &H1
    Public Const FILE_SHARE_WRITE = &H2
    Public Const FO_DELETE = &H3

    Public Funct As New SC_General
    
    Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
    (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

    Public Const LVM_FIRST = &H1000&
    Public Const LVM_HITTEST = LVM_FIRST + 18

    Public Type POINTAPI
        X As Long
        Y As Long
    End Type

    Public Type LVHITTESTINFO
       pt As POINTAPI
       Flags As Long
       iItem As Long
       iSubItem As Long
    End Type
    
    Public ToolTip As UI_Tooltip
    
    Public UserIndex As Long
    Public FriendIndex As Long
    Public ClanIndex As Long
    
    Public Const SWP_NOSIZE = &H1
    Public Const SWP_NOMOVE = &H2
    Public Const SWP_SHOWWINDOW = &H40
    Public Const HWND_NOTOPMOST = -2
    Public Const HWND_TOPMOST = -1

    Public Const LOCALE_USER_DEFAULT = &H400
    Public Const LOCALE_ILANGUAGE             As Long = &H1    'language id
    Public Const LOCALE_SLANGUAGE             As Long = &H2    'localized name of lang
    Public Const LOCALE_SENGLANGUAGE          As Long = &H1001 'English name of lang
    Public Const LOCALE_SABBREVLANGNAME       As Long = &H3    'abbreviated lang name
    Public Const LOCALE_SNATIVELANGNAME       As Long = &H4    'native name of lang
    Public Const LOCALE_ICOUNTRY              As Long = &H5    'country code
    Public Const LOCALE_SCOUNTRY              As Long = &H6    'localized name of country
    Public Const LOCALE_SENGCOUNTRY           As Long = &H1002 'English name of country
    Public Const LOCALE_SABBREVCTRYNAME       As Long = &H7    'abbreviated country name
    Public Const LOCALE_SNATIVECTRYNAME       As Long = &H8    'native name of country
    Public Const LOCALE_SINTLSYMBOL           As Long = &H15   'intl monetary symbol
    Public Const LOCALE_IDEFAULTLANGUAGE      As Long = &H9    'def language id
    Public Const LOCALE_IDEFAULTCOUNTRY       As Long = &HA    'def country code
    Public Const LOCALE_IDEFAULTCODEPAGE      As Long = &HB    'def oem code page
    Public Const LOCALE_IDEFAULTANSICODEPAGE  As Long = &H1004 'def ansi code page
    Public Const LOCALE_IDEFAULTMACCODEPAGE   As Long = &H1011 'def mac code page
    
    Public Enum sTimeDisplays
        ddhhmm
        ddhhmmss
        ddhhmmss_full
        ddhhmmssmm
        ddhhmmssmm_full
    End Enum
        
    Public Const vbLightYellow As Long = &HC0FFFF
    Public Const vbLightRed As Long = &HC0C0FF
    Public Const vbLightOrange As Long = &HC0E0FF
    Public Const vbLightGreen As Long = &HC0FFC0
    Public Const vbLightBlue As Long = &HFFC0C0
    Public Const vbLightCyan As Long = &HFFFFC0
    Public Const vbLightPurple As Long = &HFFC0FF
    Public Const vbOrange As Long = &H80FF&
    Public Const vbPurple As Long = vbMagenta

    Private lActive As Integer
    
    Public Property Let Active(iActive As Integer)
        lActive = iActive
    
        If iActive > 0 Then
            frmMain.rtbMain(Profiles(iActive).CtrlIndex).ZOrder vbBringToFront
            DisplayList All, iActive
            Profiles(iActive).IsActive = False
            frmMain.txtProfile.Text = Profiles(iActive).ProfileName
            
            Dim mConnected As Boolean
            mConnected = Profiles(iActive).Online
            
            frmMain.txtProfile.Visible = Not mConnected
            frmMain.lvUsers.Visible = mConnected
            frmMain.lvFriends.Visible = mConnected
            frmMain.lvClan.Visible = mConnected
            frmMain.Check1.Visible = Not mConnected
            frmMain.Check2.Visible = Not mConnected
            With Connection(Profiles(iActive).PacketIndex)
                frmMain.mnuACEM.Checked = .ACEM
                frmMain.mnuAFEM.Checked = .AFEM
                frmMain.mnuNFW.Checked = .NFW
                frmMain.mnuAPN.Checked = .APN
                frmMain.mnuAPF.Checked = .APF
            End With
        End If
    End Property
    
    Public Property Get Active() As Integer
        Active = lActive
    End Property
    
    Public Function tickToTime(Ticks As Long, td As sTimeDisplays) As String
        Dim Days&, Hours&, Minutes&, Seconds&, Ret$
        Dim strDays$, strHours$, strMinutes$, strSeconds$
        Days = Int(Ticks / 86400000)
        Ticks = Ticks Mod 86400000
        Hours = Int(Ticks / 3600000)
        Ticks = Ticks Mod 3600000
        Minutes = Int(Ticks / 60000)
        Ticks = Ticks Mod 60000
        Seconds = Int(Ticks / 1000)
        
        If td = ddhhmmss Then
            If Days > 0 Then strDays = Days & "d "
            If Hours > 0 Then strHours = Hours & "h "
            If Minutes > 0 Then strMinutes = Minutes & "m "
            If Seconds > 0 Then strSeconds = Seconds & "s"
            Ret = strDays & strHours & strMinutes & strSeconds
            If Right(Ret, 1) = Space$(1) Then Ret = Mid$(Ret, 1, Len(Ret) - 1)
            If Len(Ret) = 0 Then Ret = "Now"
        ElseIf td = ddhhmmss_full Then
            If Days > 0 Then strDays = Days & "days, "
            If Hours > 0 Then strHours = Hours & "hours, "
            If Minutes > 0 Then strMinutes = Minutes & "minutes, "
            If Seconds > 0 Then strSeconds = Seconds & "seconds, "
            Ret = strDays & strHours & strMinutes & strSeconds
            If Right(Ret, 2) = ", " Then Ret = Mid$(Ret, 1, Len(Ret) - 2)
            If Len(Ret) = 0 Then Ret = "Now"
        End If
        
        tickToTime = Ret
    End Function

