Attribute VB_Name = "UI_Definitions"
'///////////////////////////////////////
' MirageChat v2* Created by DDA-TriCk-E
' Source Release Date: 4th April 2006
'///////////////////////////////////////
Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Public lClan() As New UI_Clan
Public lFriends() As New UI_Friends
Public lUsers() As New UI_Users
Public Profiles() As etSetup
Public Connection() As New BNCS_Connection
Public Packet() As New BNCS_Packet

Public Const MIM_Port& = 6112

Public CA_Cdkey As String
Public CA_Product As String
Public CA_Status As String

Public Report_Content As String
Public Report_Page As String
Public Report_State As Integer

Public ThePath As String
Public ReadUserName As String
Public ReadUserIndex As Integer
Public ReadUserYou As Boolean
Public TrayReturnPassword As String

Public CurrentEmail As String
Public CurrentPassword As String

Public CharPath As String
Public GroupPath As String
Public PrefPath As String
Public StatPath As String

Public Const PING_NORMAL& = 0
Public Const PING_ZERO& = 1
Public Const PING_NEGATIVE& = 2
Public Const PING_LOW& = 3
Public Const PING_HIGH& = 4
    
    Public Type TextUrl
        URL As String
        StartPos As Long
        EndPos As Long
        Color As Long
    End Type

' List Types
'------------------------------
    Public Enum ListType
        Channel&
        Friends&
        Channels&
        Clan&
        Settings&
        All&
    End Enum

' Setup Variables
'------------------------------
    Public Type etSetup
        Comments(4) As String
        ActiveText As String
        HyperLinks() As TextUrl
        KeepAliveCounter As Integer
        UnexpectedDisconnect As Boolean
        BanCount As Double
        ProxyAuth As Boolean
        ProxyIP As String
        ProxyPort As Long
        ProxyVer As Long
        Master As String
        Trigger As String * 1
        CdkeyStatusIndicator As Integer
        CdkeyRecorded As Boolean
        LastWspTo As String
        LastWspFrom As String
        IsActive As Boolean
        LoginType As String
        MyLastEvent As Long
        IdleCounter As Long
        LastEvent As Long
        PosBeforeText As Double
        CtrlIndex As Integer
        PacketIndex As Integer

        ProfileIndex As Integer
        ProfileName As String
        ProfilePath As String
        HashPath As String
        
        Username As String
        Password As String
        Password2 As String
        Email As String
        Email2 As String
        Server As String
        Cdkey1 As String
        Cdkey2 As String
        Channel As String
        Plug As Boolean
        CdkeyStatus As String
        
        Online As Boolean
        
        CurrentClanMotd As String
        CurrentClanTag As String
        CurrentClanName As String
        CurrentClanRank As Byte
        CurrentUsername As String
        CurrentUserNamewServer As String
        CurrentChannel As String
        CurrentPing As Long
        CurrentFlags As Long
        CurrentChannelFlags As Long
        
        ChannelsRemote() As String
        ChannelsLocal() As String
        
        ConnectionTime As Long
        
        Ping As Integer
        ProductID As String * 4
        ProductByte As Byte
    End Type

' General Variables
'------------------------------
    Public Type etGeneral
        Uptime As Long
        Channel As String
    End Type

Public Sub AddLink(ByVal iConnection As Long, ByVal SelStart As Long, ByVal SelLength As Long, ByVal SelColor As Long, ByVal URL As String)
    Dim iProfile As Long
    Dim iBound As Long
    
    iProfile = Connection(iConnection).ProfileIndex
    iBound = UBound(Profiles(iProfile).HyperLinks) + 1
    ReDim Preserve Profiles(iProfile).HyperLinks(iBound)
    
    With Profiles(iProfile).HyperLinks(iBound)
        .URL = URL
        .Color = SelColor
        .StartPos = SelStart
        .EndPos = SelLength
    End With
End Sub

Public Sub FindHyperlink(ByVal iControl As Integer, start As Long)
    Dim iConnection As Long, iProfile As Long, iLoop As Long
    iConnection = Val(frmMain.wsBnet(iControl).Tag)
    iProfile = Connection(iConnection).ProfileIndex

    For iLoop = UBound(Profiles(iProfile).HyperLinks) To 1 Step -1
        If (Profiles(iProfile).HyperLinks(iLoop).StartPos <= start) And (Profiles(iProfile).HyperLinks(iLoop).EndPos >= start) Then
            Dim sUrl As String, iURL As Integer, sChannel As String
            sUrl = Profiles(iProfile).HyperLinks(iLoop).URL
            Dim T As String: T = LCase$(Split(sUrl, vbCrLf)(0))
            If T Like "clan*" Or T Like "op*" Then
                frmMain.cmbSend.Text = "/join " & T
            ElseIf T Like "profile *" Or T Like "*/profile *" Then
                frmMain.cmbSend.Text = "/profile " & Split(T, "profile ")(1)
            ElseIf T Like "channel*" Then
                frmMain.cmbSend.Text = "/join " & Mid(T, 9)
            ElseIf T Like "www.*" Then
                ShellExecute frmMain.hwnd, "OPEN", "http://" & sUrl, "", "", 5
            ElseIf T Like "http://*" Or T Like "ftp://*" Or _
                 T Like "https://*" Then
                ShellExecute frmMain.hwnd, "OPEN", sUrl, "", "", 5
            End If
        End If
    Next
End Sub

