Attribute VB_Name = "UI_Lists"
'///////////////////////////////////////
' MirageChat v2* Created by DDA-TriCk-E
' Source Release Date: 4th April 2006
'///////////////////////////////////////
Option Explicit

    Public Function GetUserListIndex(ByVal ProfileIndex As Integer, ByVal Username As String) As Integer
        Dim iLoop As Integer
        For iLoop = frmMain.lvUsers.ListItems.Count To 1 Step -1
            If LCase$(frmMain.lvUsers.ListItems.Item(iLoop).Text) = LCase$(Username) Then
                GetUserListIndex = iLoop
                Exit For
            End If
        Next iLoop
    End Function
    
    Public Function DelUserListIndex(ByVal ProfileIndex As Integer, ByVal Username As String) As Integer
        Dim iLoop As Integer
        For iLoop = frmMain.lvUsers.ListItems.Count To 1 Step -1
            If LCase$(frmMain.lvUsers.ListItems.Item(iLoop).Text) = LCase$(Username) Then
                frmMain.lvUsers.ListItems.Remove iLoop
            End If
        Next iLoop
    End Function
    
    Public Sub DisplayList(lt As ListType, Index As Integer)
        UserIndex = 0
        FriendIndex = 0
        ClanIndex = 0
        
        If lt = All Then
            frmMain.lvUsers.ListItems.Clear
            frmMain.lvFriends.ListItems.Clear
            frmMain.lvClan.ListItems.Clear
            DisplayUsers Index
            DisplayFriends Index
            DisplayClan Index
            DisplayChannels Index
            Exit Sub
        End If
        
        If lt = Channel Then
            frmMain.lvUsers.ListItems.Clear
            DisplayUsers Index
        ElseIf lt = Friends Then
            frmMain.lvFriends.ListItems.Clear
            DisplayFriends Index
        ElseIf lt = Channels Then
            DisplayChannels Index
        ElseIf lt = Clan Then
            frmMain.lvClan.ListItems.Clear
            DisplayClan Index
        End If
    End Sub

    Public Function GetUserString(ByVal Username As String) As String
        Dim iLoop As Integer, sString As String, sSplt() As String, iFind As Integer
        For iLoop = 1 To UBound(Groups())
            If InStr(Groups(iLoop), "=") > 0 Then
                sString = GetINI(PrefPath, "Group_" & Split(Groups(iLoop), "=")(0), "Users")
                If InStr(sString, ",") > 0 Then
                    sSplt = Split(sString, ",")
                    For iFind = 0 To UBound(sSplt)
                        If LCase$(sSplt(iFind)) = LCase$(Username) Then
                            GetUserString = Split(Groups(iLoop), "=")(1)
                            Exit Function
                        End If
                    Next
                End If
            End If
        Next iLoop
    End Function
    
    Public Function GetUserGroup(ByVal Username As String) As String
        Dim iLoop As Integer, sString As String, sSplt() As String, iFind As Integer
        For iLoop = 1 To UBound(Groups())
            If InStr(Groups(iLoop), "=") > 0 Then
                sString = GetINI(PrefPath, "Group_" & Split(Groups(iLoop), "=")(0), "Users")
                If InStr(sString, ",") > 0 Then
                    sSplt = Split(sString, ",")
                    For iFind = 0 To UBound(sSplt)
                        If LCase$(sSplt(iFind)) = LCase$(Username) Then
                            GetUserGroup = Split(Groups(iLoop), "=")(0)
                            Exit Function
                        End If
                    Next iFind
                End If
            End If
        Next iLoop
    End Function

    Private Sub DisplayUsers(Index As Integer)
        Dim iLoop As Integer
        Dim vItem As New UI_UserItem
        Dim sUserStr As String
        frmMain.txtProfile.Text = Profiles(Active).ProfileName
        frmMain.lvUsers.ListItems.Clear
        For iLoop = 1 To lUsers(Index).GetCount
            Set vItem = lUsers(Index).GetItemByIndex(iLoop)
            
            If (vItem.Flags And &H2) = &H2 Then
                With frmMain.lvUsers.ListItems.Add(1, , vItem.Username, , GetClientIcon(vItem.Statstring, vItem.Flags))
                    .ListSubItems.Add(, , , GetPingIcon(vItem.Ping, vItem.Flags)).Tag = vItem.Statstring
                    If vItem.Username = Profiles(Active).CurrentUsername Then .Bold = True
                    .Tag = vItem.RealName
                    
                    sUserStr = GetUserString(vItem.Username)
                    If InStr(sUserStr, ";") > 0 Then
                        .ForeColor = IIf(Val(Split(sUserStr, ";")(0)) <> 0, Val(Split(sUserStr, ";")(0)), vbWhite)
                        .Bold = IIf(Val(Split(sUserStr, ";")(1)) = 1, True, False)
                    End If
                End With
            End If
        Next
        
        For iLoop = 1 To lUsers(Index).GetCount
            Set vItem = lUsers(Index).GetItemByIndex(iLoop)
            
            If (vItem.Flags And &H2) <> &H2 Then
                With frmMain.lvUsers.ListItems.Add(, , vItem.Username, , GetClientIcon(vItem.Statstring, vItem.Flags))
                    .ListSubItems.Add(, , , GetPingIcon(vItem.Ping, vItem.Flags)).Tag = vItem.Statstring
                    If vItem.Username = Profiles(Active).CurrentUsername Then .Bold = True
                    .Tag = vItem.RealName
                    
                    sUserStr = GetUserString(vItem.Username)
                    If InStr(sUserStr, ";") > 0 Then
                        .ForeColor = IIf(Val(Split(sUserStr, ";")(0)) <> 0, Val(Split(sUserStr, ";")(0)), vbWhite)
                        .Bold = IIf(Val(Split(sUserStr, ";")(1)) = 1, True, False)
                    End If
                End With
            End If
        Next
    End Sub

    Private Sub DisplayChannels(Index As Integer)
        Dim iLoad As Integer, iBound As Integer, iUnload As Integer
        
        frmMain.mnuLoadBnetChannels(0).Visible = True
        For iUnload = frmMain.mnuLoadBnetChannels.UBound To 1 Step -1
            Unload frmMain.mnuLoadBnetChannels.Item(iUnload)
        Next iUnload

        iBound = frmMain.mnuLoadBnetChannels.UBound + 1
        Load frmMain.mnuLoadBnetChannels(iBound)
        frmMain.mnuLoadBnetChannels(iBound).Caption = "-"
        iBound = frmMain.mnuLoadBnetChannels.UBound + 1
        Load frmMain.mnuLoadBnetChannels(iBound)
        frmMain.mnuLoadBnetChannels(iBound).Caption = "Battle.net Channels"
        frmMain.mnuLoadBnetChannels(iBound).Enabled = False
        iBound = frmMain.mnuLoadBnetChannels.UBound + 1
        Load frmMain.mnuLoadBnetChannels(iBound)
        frmMain.mnuLoadBnetChannels(iBound).Caption = "-"
        frmMain.mnuLoadBnetChannels(iBound).Enabled = True

        With Profiles(Active)
            For iLoad = LBound(.ChannelsRemote) To UBound(.ChannelsRemote)
                If Len(.ChannelsRemote(iLoad)) > 0 Then
                    iBound = frmMain.mnuLoadBnetChannels.UBound + 1
                    Load frmMain.mnuLoadBnetChannels(iBound)
                    frmMain.mnuLoadBnetChannels(iBound).Caption = _
                        .ChannelsRemote(iLoad)
                End If
            Next iLoad
        End With
        If (frmMain.mnuLoadBnetChannels.UBound > 0) Then frmMain.mnuLoadBnetChannels(0).Visible = False

        frmMain.mnuLoadChannels(0).Visible = True
        iUnload = 0
        For iUnload = frmMain.mnuLoadChannels.UBound To 1 Step -1
            Unload frmMain.mnuLoadChannels.Item(iUnload)
        Next iUnload

        iLoad = frmMain.mnuLoadChannels.UBound + 1
        Load frmMain.mnuLoadChannels(iLoad)
        frmMain.mnuLoadChannels(iLoad).Caption = "-"
        iLoad = frmMain.mnuLoadChannels.UBound + 1
        Load frmMain.mnuLoadChannels(iLoad)
        frmMain.mnuLoadChannels(iLoad).Caption = "Personal Channels"
        frmMain.mnuLoadChannels(iLoad).Enabled = False
        iLoad = frmMain.mnuLoadChannels.UBound + 1
        Load frmMain.mnuLoadChannels(iLoad)
        frmMain.mnuLoadChannels(iLoad).Caption = "-"
        frmMain.mnuLoadChannels(iLoad).Enabled = True
        
        With Profiles(Active)
            For iLoad = LBound(.ChannelsLocal) To UBound(.ChannelsLocal)
                If Len(.ChannelsLocal(iLoad)) > 0 Then
                    iBound = frmMain.mnuLoadChannels.UBound + 1
                    Load frmMain.mnuLoadChannels(iBound)
                    frmMain.mnuLoadChannels(iBound).Caption = _
                        .ChannelsLocal(iLoad)
                End If
            Next iLoad
        End With
        If (frmMain.mnuLoadChannels.UBound > 0) Then frmMain.mnuLoadChannels(0).Visible = False
    End Sub

    Private Sub DisplayFriends(Index As Integer)
        Dim iLoop As Integer, iIcon As Integer
        For iLoop = 1 To lFriends(Index).Count
            lFriends(Index).lIndex = iLoop
            If lFriends(Index).Statstring = vbNullChar & vbNullChar & vbNullChar & vbNullChar Then iIcon = 0 Else iIcon = GetClientIcon(lFriends(Index).Statstring, 0)
            frmMain.lvFriends.ListItems.Add , , lFriends(Index).Username, , iIcon
        Next iLoop
    End Sub

    Private Sub DisplayClan(Index As Integer)
        Dim iLoop As Integer, iIcon As Integer
        For iLoop = 1 To lClan(Index).Count
            lClan(Index).lIndex = iLoop
            iIcon = GetClanIcon(lClan(Index).Rank)
            frmMain.lvClan.ListItems.Add , , lClan(Index).Username, , iIcon
        Next iLoop
    End Sub

    Public Sub DisplayProxies()
        Dim iLoop As Integer, iBound As Integer, iLoad As Integer, sSplt() As String, sStatus As String
        For iLoop = frmMain.mnuProxies.UBound To 1 Step -1
            Unload frmMain.mnuProxies(iLoop)
        Next iLoop
        
        For iBound = 1 To UBound(Proxies())
            sSplt() = Split(Proxies(iBound), " ")
            If UBound(sSplt()) = 2 Then
                Select Case sSplt(1)
                    Case "*": sStatus = "Not Auth'd"
                    Case "**": sStatus = "Good"
                    Case "x": sStatus = "Bad"
                    Case Else: sStatus = "Unknown"
                End Select
                
                iLoad = frmMain.mnuProxies.UBound + 1
                Load frmMain.mnuProxies(iLoad)
                frmMain.mnuProxies(iLoad).Caption = sSplt(2) & "   |   " & sSplt(0) & vbTab & sStatus
                frmMain.mnuProxies(iLoad).Tag = sSplt(0)
            End If
        Next iBound
    End Sub

