VERSION 5.00
Begin VB.Form frmTray 
   Caption         =   "Tray"
   ClientHeight    =   735
   ClientLeft      =   165
   ClientTop       =   675
   ClientWidth     =   2295
   Icon            =   "frmTray.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   735
   ScaleWidth      =   2295
   StartUpPosition =   2  'CenterScreen
   Begin VB.Menu mnuTray 
      Caption         =   "Tray"
      Begin VB.Menu mnuRestore 
         Caption         =   "Restore"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "Exit"
      End
   End
End
Attribute VB_Name = "frmTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'///////////////////////////////////////
' MirageChat v2* Created by DDA-TriCk-E
' Source Release Date: 4th April 2006
'///////////////////////////////////////
Option Explicit
Private Type NotifyIconData
  Size As Long
  handle As Long
  ID As Long
  Flags As Long
  CallBackMessage As Long
  Icon As Long
  Tip As String * 64
End Type
Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" _
    (ByVal dwMessage As Long, pnid As NotifyIconData) As Boolean

Const NIM_ADD = &H0    ' Add an icon
Const NIM_MODIFY = &H1 ' Modify an icon
Const NIM_DELETE = &H2 ' Delete an icon

Const NIF_MESSAGE = &H1       ' To change uCallBackMessage member
Const NIF_ICON = &H2          ' To change the icon
Const NIF_TIP = &H4           ' To change the tooltip text

'nid.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE


Const WM_MOUSEMOVE = &H200
Const WM_LBUTTONDOWN = &H201   ' Left click
Const WM_LBUTTONDBLCLK = &H203 ' Left double click
Const WM_RBUTTONDOWN = &H204   ' Right click
Const WM_RBUTTONDBLCLK = &H206 ' Right double click

Public InTray As Boolean
Dim nid As NotifyIconData
Dim CurrentTooltip As String

Public Function GetTooltip() As String
    GetTooltip = CurrentTooltip
End Function

Public Sub SetTooltip(strTooltip)
    CurrentTooltip = strTooltip
    nid.Tip = strTooltip & vbNullChar
    Shell_NotifyIcon NIM_MODIFY, nid
End Sub

Public Sub SendToTray()
    nid.Size = Len(nid)
    nid.handle = hwnd
    nid.ID = 0
    nid.Flags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    nid.CallBackMessage = WM_MOUSEMOVE
    nid.Icon = frmMain.Icon
    nid.Tip = version() & vbNullChar
    Shell_NotifyIcon NIM_ADD, nid
    InTray = True
    'frmMain.WindowState = vbMinimized
    'frmMain.Hide
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, _
    Y As Single)
    Dim Msg As Long
    Msg = ScaleX(X, ScaleMode, vbPixels)
    
    Select Case Msg
        Case WM_LBUTTONDBLCLK
            mnuRestore_Click
        Case WM_RBUTTONDOWN
            If frmMain.Visible = True Then
                mnuRestore.Caption = "Hide"
            Else
                mnuRestore.Caption = "Restore"
            End If
            PopupMenu mnuTray, , , , mnuRestore
    End Select
End Sub

Private Sub Form_Resize()
    mnuRestore_Click
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Shell_NotifyIcon NIM_DELETE, nid
End Sub

Private Sub mnuExit_Click()
    If TrayReturn = False Then Exit Sub
    InTray = False
    frmMain.WindowState = vbNormal
    frmMain.Show
    Unload Me
    Unload frmMain
End Sub

Private Function TrayReturn() As Boolean
    Dim TR As String, CR As String
    TR = GetINI(PrefPath, "Settings", "TrayReturn")
    
    If Len(TR) > 0 Then
        On Error Resume Next
        Dim sRetVal As String
        sRetVal = MessageBox(Me, "Enter password for tray return", "Tray Return Password")
        CR = sRetVal
        If LCase$(TR) <> LCase$(CR) Then TrayReturn = False: MsgBox "Incorrect Password Entered!", vbExclamation + vbOKOnly, "Wrong Password": Exit Function
    End If
    TrayReturn = True
End Function

Public Sub mnuRestore_Click()
    If frmMain.WindowState = vbMinimized Then
        If TrayReturn = False Then Exit Sub
        Unload frmMessage
        frmMain.WindowState = vbNormal
        frmMain.Show
        Dim iLoop As Form
        For Each iLoop In Forms
            If iLoop.Name = "frmTrayControl" Then
                Unload iLoop
            End If
        Next
    Else
        frmMain.WindowState = vbMinimized
        frmMain.Hide
    End If
    InTray = False
End Sub
